﻿using System;
using System.Collections.Generic;
using TheGameExtreme.model.card;
using TheGameExtreme.model.card.rapidCard;

namespace TheGameExtreme.model.rule.endTurnRules
{
    public class EndGame : EndTurnRule
    {

        public static readonly String REGLE_ENDGAME = "End Game";

        public List<Stack<Card>> ListOrderedStacks { get; set; }

        public EndGame(List<Stack<Card>> ListOrderedStacks)
        {
            this.ListOrderedStacks = ListOrderedStacks;
        }

        public override bool Test(List<Card> CurrentCardPlayed, int nbCardAtBeginOfTurn, List<Card> CurrentHand)
        {
            if (CurrentHand.Count != 0)
            {
                List<Card> playableCard = new List<Card>();
                tryToFindSoluce(playableCard, CurrentHand);
                return testEndGame(playableCard);
            }
            return false;
        }

        protected void tryToFindSoluce(List<Card> playableCard, List<Card> CurrentHand)
        {
            CurrentHand.ForEach(card =>
            {
                if (card.Value > ListOrderedStacks[0].Peek().Value || card.Value > ListOrderedStacks[1].Peek().Value || card.Value < ListOrderedStacks[2].Peek().Value || card.Value < ListOrderedStacks[3].Peek().Value)
                {
                    playableCard.Add(card);
                }
            });
        }

        protected bool testEndGame(List<Card> playableCard)
        {
            if (playableCard.Count == 2)
            {
                foreach (Card c in playableCard)
                {
                    if (Equals(c.getName(), ThreeCard.CARD_THREE))
                    {
                        return false;
                    }
                }
            }
            else if (playableCard.Count < 2)
            {
                return false;
            }
            return true;
        }

    }
}
